stages:
  - build
  - lint
  - test
  - staging


cache:
  untracked: true
  key: "$CI_BUILD_REF_NAME"
  paths:
    - node_modules/


###########################################
############ START BUILD STAGE ############
###########################################

build project:
  stage: build
  # IMAGE TYPE IS FOR DOCKER IMAGE
  image: node
  # SCRIPTS TO RUN DURING THE BUILD STAGE
  script:
    - echo $CI_COMMIT_SHORT_SHA
    - npm install
    - npm run build
  # ARTIFACTS FOR NEXT PHASE OF PIPELINE
  artifacts:
    paths:
      - public


###########################################
############ START LINT STAGE #############
###########################################

run eslint on project:
  stage: lint
  image: node
  script:
    - npm run lint:js


run style lint on project:
  stage: lint
  image: node
  script:
    - npm run lint:styles

###########################################
############ START TEST STAGE #############
###########################################


test:coverage-report:
  stage: test
  image: node
  script:
    - echo "Test coverage report being generated..."
    - npm run test:coverage
    - echo "Coverage Report Successful"
  artifacts:
    paths:
      - coverage


###########################################
############ START STAGING STAGE ##########
###########################################

deploy:staging:
  stage: staging
  image: node
  only: 
    - master
  script:
    - echo "Running staging step"
  